Rem


title and sidebar paint



sound
damaged hum
menu blip
goggle hum
explosion
pickup
title present
G.O.

EndRem


' ROBOTS AMONG US
' A Ludum Dare entry by Arne, 2010
' Sloppy code ahoy. Written/gfxed in <12 hrs.
Strict
AppTitle = "Robots Among Us v0.25a"
SeedRnd(MilliSecs())
Const SCREEN_WIDTH:Int = 640
Const SCREEN_HEIGHT:Int = 480
Graphics SCREEN_WIDTH, SCREEN_HEIGHT, 0
Const ARENA_TOPMARGIN:Int=24
Const ARENA_WIDTH:Int = 432
Const ARENA_HEIGHT:Int = 432
Const ARENA_LEFTMARGIN:Int = 52*2
Const ARENA_RIGHTMARGIN:Int = 268*2
Const ARENA_BOTTOMMARGIN:Int = 480-24
'Print ARENA_WIDTH
'Print ARENA_RIGHTMARGIN-ARENA_LEFTMARGIN
TGuy.FBoot()
TLevel.FBoot()
TPlayerStats.FBoot()


Const PLAYMODE:Int=0
Const GAMEOVERMODE:Int=1
Const TITLEMODE:Int=2
Const NEXTLEVELMODE:Int=3
Const SCOREMODE:Int=4
Const EXPLOMODE:Int=5
Const SPLATMODE:Int=6
Global GameMode = TITLEMODE
Global ModeCounter = 0
Global TitleGfx:TImage
TitleGfx = LoadImage ("title.bmp",0)
If Not TitleGfx Then Print "Img file missing" End	

Global SndExplosion:TSound = LoadSound("sound/explosion.wav")
Global SndGameOver:TSound = LoadSound("sound/gameover.wav")
Global SndHit:TSound = LoadSound("sound/hit.wav")
Global SndPickup:TSound = LoadSound("sound/pickup.wav")
Global SndScan:TSound = LoadSound("sound/scan.wav")
Global SndStart:TSound = LoadSound("sound/start.wav")
Global SndSelect:TSound = LoadSound("sound/select.wav")
Global SndShoot:TSound = LoadSound("sound/shoot.wav")


While Not KeyDown (KEY_ESCAPE)
If AppTerminate() Then Exit
	Cls
	
	Select GameMode
	Case PLAYMODE
	
		TGuy.FUpdateAll()
		TGuy.FPlayerUpdate()
		TPlayerStats.FAlertDist() ' Update
		
		TPlayerStats.FDrawHud()
		TLevel.FDrawMap()
		TGuy.FDrawAll()
		
		
		
	Case SPLATMODE
		TPlayerStats.FDrawHud()
		TLevel.FDrawMap()
		TGuy.FDrawAll()
		ModeCounter:-1
		If ModeCounter=0 Then GameMode=GAMEOVERMODE FlushKeys() FlushMouse()
		
	Case EXPLOMODE
		TPlayerStats.FDrawHud()
		TLevel.FDrawMap()
		TGuy.FDrawAll()
		ModeCounter:-1
		If ModeCounter=0 Then GameMode=NEXTLEVELMODE FlushKeys() FlushMouse()
	
	Case TITLEMODE
		SetColor 255,255,255
		SetScale 2,1
			DrawImage TitleGfx,0,0
		SetScale 2,1
		DrawText "Hit Mouse to play!", 20,400
		SetColor 160,160,160
		DrawText "A Ludum Dare entry by Arne, 2010", 20,460
		If MouseHit(1)
			PlaySound SndStart
			GameMode=NEXTLEVELMODE
			TLevel.FDefaultState()
		EndIf
	Case NEXTLEVELMODE
			TLevel.FNewLevelState()
			GameMode=SCOREMODE
	Case SCOREMODE

		TLevel.FDrawIntermission()
		If MouseHit(1)
			GameMode=PLAYMODE
			PlaySound SndSelect
		EndIf
	Case GAMEOVERMODE
		SetColor 255,255,255
		SetScale 2,1
		DrawText "GAME OVER", 230,220
		If MouseHit(1)
			GameMode=TITLEMODE
			PlaySound SndSelect
		EndIf
	End Select
	'Delay 10
	Flip 1
Wend
End


Type TPlayerStats

	Global AlertDist:Float
	Global Level
	Global Score
	Global Goggles, Gun, Explosives
	Global Health:Float
	Global TimeBonus
	Global Running
	Global RunTime 
	Global ShotsFired
	Global GogglesUsed
	Global AlertAngle
	Global TopScore
	Global DamselPickup
	Global Hint
	Global PlayGfx:TImage
	
	Function FBoot()
		PlayGfx = LoadImage ("playBG.bmp",0)
		If Not PlayGfx Then Print "Img file missing" End	
	End Function
	
	Function FDefaultState()
		Level=0
		Score=0
		Goggles=False
		Gun=False
		Explosives=False
		Health=100
		Running = False
		AlertDist = 25
		TimeBonus=0
	End Function
	
	Function FNewLevelState()
		Level:+1
		Goggles=False
		GogglesUsed=0
		Gun=False
		ShotsFired=0
		Explosives=False
		Health=100
		Running = False
		RunTime=0
		'AlertDist = 25
		TimeBonus=800
		DamselPickup=0
		
		Hint=False
		'Print "FNewLevelState()"
	End Function
	
	Function FRegenHealth(h:Float)
		Health:+h
		If Health => 100 Then Health = 100
	End Function
		
	Function FTakeDamage(d:Float)
		Health:-d
		If Health < 0 Then Health = 0 GameMode=SPLATMODE TopScore=Score ModeCounter=60 PlaySound SndGameOver
	End Function
	
	Function FAlertDist()
		AlertDist= 25+(RunTime*0.02)+(ShotsFired*2)+(GogglesUsed*1)+(Goggles*10)
		AlertAngle:+11
		If AlertAngle=>360 Then AlertAngle=0
	End Function

	
	Function FToggleGoggles()
		GogglesUsed:+1
		If Goggles = False Then Goggles = True Else Goggles = False
	End Function
	
	Function FDrawHud()
	SetColor 255,255,255
	SetScale 2,1
	DrawImage PlayGfx,0,0
		SetScale 1,1
		SetColor 80,0,0
		DrawRect 200+68*2-((100-Health)*2),9,((100-Health)*2),8
		SetColor 255,255,255
		SetScale 2,1
		Local XHandle=400
		
		
		If Hint Then DrawImage TGuy.ItemGfx, XHandle+0,12, 6
		If Explosives Then DrawImage TGuy.ItemGfx, XHandle+32,12, 1
		If Gun Then DrawImage TGuy.ItemGfx, XHandle+64,12, 2
		If DamselPickup Then DrawImage TGuy.ItemGfx, XHandle+96,12, 4
		DrawText "L:" + Level + "  Score:" + Score+"  Top: " + TopScore, 60*2,SCREEN_HEIGHT-20
		SetScale 1,1
	End Function
	
End Type


Type TLevel
	Global Bonus1, Bonus2, Bonus3, Bonus4, Total

	Global Map:Int[3,3]
	Global TerrainGfx:TImage
	
	Function FBoot()
		SetMaskColor 0,0,0
		TerrainGfx=LoadAnimImage("terrain.bmp",144/2, 144,0,6+6,MASKEDIMAGE)
		If Not TerrainGfx Then Print "Img file missing" End	
	End Function
	

	Function FDefaultState()
		TPlayerStats.FDefaultState()
	End Function

	Function FDrawMap()
		Local x,y
		SetScale 2,1
		If TPlayerStats.Goggles
			For y=0 To 2
			For x=0 To 2
				DrawImage TerrainGfx, x*144+ARENA_LEFTMARGIN, y*144+ARENA_TOPMARGIN, Map[x,y]
			Next
			Next
		Else
			For y=0 To 2
			For x=0 To 2
				DrawImage TerrainGfx, x*144+ARENA_LEFTMARGIN, y*144+ARENA_TOPMARGIN, Map[x,y]+6
			Next
			Next
		EndIf
		SetScale 1,1
		
	End Function
	
	Function FRndMap()
		Local x,y
		For y=0 To 2
		For x=0 To 2
			Map[x,y]=Rnd(6)
		Next
		Next
		'Map[1,1]=0
	End Function

	Function FNewLevelState()
		FRndMap()
		'Calculate from last level
		If TPlayerStats.Level=0
			Bonus1=0
			Bonus2=0
			Bonus3=0
			Bonus4=0
			Total=0
		Else
		
		Bonus1 =	TPlayerStats.TimeBonus
		Bonus2 = 	TPlayerStats.Level*100
		Bonus3 = (50 - TPlayerStats.AlertDist)*10
		Bonus4 = TPlayerStats.DamselPickup*300
		If Bonus3<0 Then Bonus3=0
		Total=Bonus1+Bonus2+Bonus3+Bonus4
		TPlayerStats.Score:+Total
		EndIf
		
		TPlayerStats.FNewLevelState()
		
		TGuy.FClearLists()
		Select TPlayerStats.Level
		Case 1 TGuy.FCreate(20,7)
		Case 2 TGuy.FCreate(33,10)
		Case 3 TGuy.FCreate(60,15)
		Case 4 TGuy.FCreate(20,23)
		Case 5 TGuy.FCreate(80,28)
		Default TGuy.FCreate(90,30)
		End Select
		
	End Function
	
	Function FDrawIntermission()
	
		SetColor 255,255,255
		SetScale 2,1
		DrawText "INTERMISSION ", 100,20
		DrawText "Prepare for Level "+ (TPlayerStats.Level), 100,40
		Local XHandle=100
		If TPlayerStats.Level = 1
		SetColor 160,160,160
		DrawText "Avoid the cloaked evil robots",XHandle,100
		DrawText "who have infiltrated mankind.",XHandle,120
		DrawText "Locate their cloaking device ",XHandle,140
		DrawText "and blow it up with C4.",XHandle,160
		SetColor 255,255,255
			DrawText "Move the mouse to   WALK",XHandle,200
			DrawText "Left mouse btn. to  RUN",XHandle,220
			DrawText "Right mouse btn. to SEE",XHandle,240
			
		Else
			SetColor 160,160,160
			DrawText "Time   : " +Bonus1,XHandle,100
			DrawText "Level  : " +Bonus2,XHandle,120
			DrawText "Stealth: " +Bonus3,XHandle,140
			DrawText "Damsels: " +Bonus4,XHandle,160
			DrawText "Total  : " +Total,XHandle,180
			SetColor 255,255,255
			DrawText "SCORE  : " +TPlayerStats.Score,XHandle,220
		EndIf
	End Function
	
End Type









Type TGuy

	Field XVel:Float, YVel:Float
	Field XPos:Float, YPos:Float
	Field Ang, Turn
	Field Gfx:Byte[3]
	Field ChaseMode
	Field Attacking
	Field WalkFrame
	Field Dead
	Global RList:TList ' Robots
	Global HList:TList ' Humans
	Global BList:TList ' Buildings
	Global IList:TList ' Items
	Global Player:TGuy
	Global BodyGfx:TImage, TopGfx:TImage, BottomGfx:TImage, ItemGfx:TImage, ExploGfx:TImage, SplatGfx:TImage, JunkGfx:TImage
	Global GlobalWalkFrame
	Global GlobalRunFrame
	Global FrameCounter
	Global Explosives:TGuy
	Global Damsel:TGuy
	Global Gun:TGuy
	Global Hint:TGuy
	Global Cloak:TGuy
	
	Function FBoot()
		RList = New TList
		HList = New TList
		SetMaskColor 0,0,0
		BodyGfx=LoadAnimImage("bodies.bmp",8,16,0,16+16+4,MASKEDIMAGE)
		If Not BodyGfx Then Print "Img file missing" End
		MidHandleImage BodyGfx
		TopGfx=LoadAnimImage("tops.bmp",8,4,0,16,MASKEDIMAGE)
		If Not TopGfx Then  Print "Img file missing" End
		MidHandleImage TopGfx
		BottomGfx=LoadAnimImage("bottoms.bmp",8,4,0,16,MASKEDIMAGE)
		If Not BottomGfx Then  Print "Img file missing" End
		MidHandleImage BottomGfx
		ItemGfx=LoadAnimImage("pickups.bmp",16,16,0,7,MASKEDIMAGE)
		If Not ItemGfx Then  Print "Img file missing" End
		MidHandleImage ItemGfx
		ExploGfx=LoadImage("explosion.bmp",MASKEDIMAGE)
		If Not ExploGfx Then  Print "Img file missing" End
		MidHandleImage ExploGfx
		SplatGfx=LoadImage("splat.bmp",MASKEDIMAGE)
		If Not SplatGfx Then  Print "Img file missing" End
		MidHandleImage SplatGfx
		JunkGfx=LoadImage("junk.bmp",MASKEDIMAGE)
		If Not JunkGfx Then  Print "Img file missing" End
		MidHandleImage JunkGfx
	End Function
	
	Function FClearLists()
		ClearList(RList)
		ClearList(HList)
		Player=Null
		Explosives=Null
		Damsel=Null
		Gun=Null
		Cloak=Null
	End Function
	
	Function FCreate(h,r)
		Local t:TGuy, i
		For i=1 To h
			t = New TGuy
			t.MRndPlace()
			HList.AddLast t
		Next
		
		For i=1 To r
			t = New TGuy
			t.MRndPlace()
			RList.AddLast t
		Next
		
		Player = New TGuy
		Player.XPos = SCREEN_WIDTH/2
		Player.YPos = SCREEN_HEIGHT/2
		
		Explosives = New TGuy
		Explosives.MRndPlace()
		Damsel = New TGuy
		Damsel.MRndPlace()
		Hint = New TGuy
		Hint.MRndPlace()
		Gun = New TGuy
		Gun.MRndPlace()
	End Function
	

	
	
	Method MRndPlace()
		Local allowed = False
		Repeat
		XPos=Rnd(ARENA_WIDTH)
		YPos=Rnd(ARENA_HEIGHT)
		allowed=True
		If XPos>ARENA_WIDTH/2-70 And XPos<ARENA_WIDTH/2+70
		If YPos>ARENA_HEIGHT/2-70 And YPos<ARENA_HEIGHT/2+70
		allowed = False
		EndIf
		EndIf
		Until allowed=True
		XPos:+ARENA_LEFTMARGIN
		YPos:+ARENA_TOPMARGIN
		Ang=Rnd(360)
		Turn=0
		
		' Appearance
		Local sex
		sex=Rnd(2)
		If sex=0 ' Female
			Gfx[0]=Rnd(16)
			Gfx[1]=Rnd(16) ' (Unisex)
			Gfx[2]=Rnd(16) ' (Unisex)
		Else ' male
			Gfx[0]=Rnd(16)+16
			Gfx[1]=Rnd(8)+8
			Gfx[2]=Rnd(8)+8
		EndIf
		WalkFrame=Rnd(2)
		Dead=False
	End Method
	
	
	
	Function FDrawAll()
	
		Player.MPlayerDraw()
		
		Local t:TGuy
		For t=EachIn RList
			t.MDrawRobot()
		Next
		
		For t=EachIn HList
			t.MDrawHuman()
		Next
		
		SetScale 2,1
		If Explosives<>Null
				DrawImage ItemGfx, Explosives.Xpos, Explosives.YPos, 1
		EndIf
		If Damsel<>Null
			DrawImage ItemGfx, Damsel.Xpos, Damsel.YPos, 3
		EndIf
		If Gun<>Null
				DrawImage ItemGfx, Gun.Xpos, Gun.YPos, 2
		EndIf
		If Hint<>Null
			DrawImage ItemGfx, Hint.Xpos, Hint.YPos, 6
		EndIf
		If Cloak<>Null
			If GameMode=EXPLOMODE	
				DrawImage ExploGfx, Cloak.Xpos, Cloak.YPos
			Else
				DrawImage ItemGfx, Cloak.Xpos, Cloak.YPos, 5
			EndIf
		EndIf
		
		
	End Function
	
	
	Function FUpdateAll()
		Local t:TGuy
		For t=EachIn RList
			t.MUpdateRobot()
		Next
		For t=EachIn HList
			t.MUpdateHuman()
		Next
		FrameCounter:+1
		If Framecounter=10 Or FrameCounter=20
			If GlobalRunFrame=0 Then GlobalRunFrame = 1 Else GlobalRunFrame=0
		EndIf
		If FrameCounter>20
			FrameCounter=0
			If GlobalWalkFrame=0 Then GlobalWalkFrame = 1 Else GlobalWalkFrame=0
			TPlayerStats.TimeBonus:-5
			If TPlayerStats.TimeBonus<0 Then TPlayerStats.TimeBonus=0
		EndIf
	End Function
	
	
	
	
	' HUMAN -----------------------------------------------------
	
	Method MUpdateHuman()
		MRoam()
		XVel=Sin(Ang)*0.3
		YVel=-Cos(Ang)*0.3
		MAddVel()
	End Method
	

	Method MDrawHuman()
		If GlobalWalkFrame = WalkFrame 
			SetScale 2,1
		Else
			SetScale -2,1
		EndIf
		If TPlayerStats.Goggles=False
		SetColor 255,255,255
		DrawImage BodyGfx, XPos, YPos, Gfx[0]
		DrawImage TopGfx, XPos, YPos+1, Gfx[1]
		DrawImage BottomGfx, XPos, YPos+6, Gfx[2]
		Else ' Gray? Green?
		SetColor 255,255,255
		DrawImage BodyGfx, XPos, YPos, 35
		EndIf
		'SetColor 255,0,255
		'Plot Xpos,Ypos
	End Method		




	
	' ROBOT -----------------------------------------------------

	Method MUpdateRobot()
		If Dead Then Return
		Local d = FDistToTarget(Player.XPos,Player.YPos, XPos,YPos)
		If d < TPlayerStats.AlertDist Then ChaseMode=True Else If d > TPlayerStats.AlertDist+10 Then ChaseMode=False ' Chase or let go
		' AI steering
		If ChaseMode=True
			' Find angle to player and randomize?
			If Player<> Null And Rnd(1)<0.05 
				Ang = FAngleToTarget(Player.XPos,Player.YPos, XPos,YPos)
				Ang = FRndAng(Ang) 
			EndIf
			If d<20 
				If TPlayerStats.Gun
					' Han shot first
					TPlayerStats.Gun = False
					Dead=True
					PlaySound SndShoot
				Else
				TPlayerStats.FTakeDamage(0.7)
				Attacking = True
				If Rnd(1)<0.1 Then PlaySound SndHit
				EndIf
			Else
				Attacking = False
			EndIf
			XVel=Sin(Ang)*0.54
			YVel=-Cos(Ang)*0.54
		Else
			MRoam()
			XVel=Sin(Ang)*0.3
			YVel=-Cos(Ang)*0.3
		EndIf

		' Move
		MAddVel()
	End Method
	
	Method MDrawRobot()
		If Dead 
			SetScale 2,1
			SetColor 255,255,255
			DrawImage JunkGfx, XPos, YPos
		Else
		
	
		If GlobalWalkFrame = WalkFrame 
			SetScale 2,1
		Else
			SetScale -2,1
		EndIf

		
		If TPlayerStats.Goggles=False ' Human cloak
		SetColor 255,255,255
		DrawImage BodyGfx, XPos, YPos, Gfx[0]
		DrawImage TopGfx, XPos, YPos+1, Gfx[1]
		DrawImage BottomGfx, XPos, YPos+6, Gfx[2]
		Else 
		SetColor 255,255,255
		DrawImage BodyGfx, XPos, YPos, 32
		EndIf
		
		If Attacking
			Local i
			For i=0 To 3
			Local a=Rnd(360)
			Local x = XPos +Sin(a)*(10+Rnd(14))
			Local y = YPos -Cos(a)*(10+Rnd(14))
			SetColor 0,255,255
			Plot x,y Plot x+1,y
			Next
		EndIf
		EndIf
		'SetColor 255,0,255
		'Plot Xpos,Ypos
	End Method
	

	

	
	
	
	' PLAYER -----------------------------------------------------
	
	Function FPlayerUpdate() 
		Player.MPlayerUpdate()
	End Function
	
	Method MPlayerUpdate()
		If MouseHit(2)
			TPlayerStats.FToggleGoggles()
		EndIf
		If TPlayerStats.Goggles Then TPlayerStats.FTakeDamage(0.05) Else TPlayerStats.FRegenHealth(0.05)
		

		If MouseDown(1) Then TPlayerStats.Running = True Else TPlayerStats.Running  = False
		
			Local mx = MouseX()
			Local my = MouseY()
			If FWithinArenaBounds(mx,my)
				Ang=FAngleToTarget(mx,my,XPos,YPos)
			EndIf
		
		
		
		If TPlayerStats.Running
			XPos:+Sin(Ang)*0.60
			YPos:-Cos(Ang)*0.60
			TPlayerStats.RunTime:+1
		Else
			XPos:+Sin(Ang)*0.4
			YPos:-Cos(Ang)*0.4
		EndIf
		If XPos<ARENA_LEFTMARGIN Then Ang = 90
		If YPos<ARENA_TOPMARGIN Then Ang = 180
		If XPos=>ARENA_RIGHTMARGIN Then Ang = 270
		If YPos=>ARENA_BOTTOMMARGIN Then Ang = 0
		
		
		' Sloppier the closer the deadline gets
		If Explosives<>Null
		If FDistToTarget(Explosives.XPos, Explosives.YPos, XPos,YPos)<10
			Explosives = Null 
			TPlayerStats.Explosives = True
			PlaySound SndPickup
		EndIf
		EndIf
		If Damsel<>Null
		If FDistToTarget(Damsel.XPos, Damsel.YPos, XPos,YPos)<10
			Damsel = Null 
			TPlayerStats.DamselPickup = True
			PlaySound SndPickup
		EndIf
		EndIf
		If Gun<>Null
		If FDistToTarget(Gun.XPos, Gun.YPos, XPos,YPos)<10
			Gun = Null 
			TPlayerStats.Gun = True
			PlaySound SndPickup
		EndIf
		EndIf
		If Hint<>Null
		If FDistToTarget(Hint.XPos, Hint.YPos, XPos,YPos)<10
			Hint = Null 
			TPlayerStats.Hint = True
			'Create Cloak
			Cloak = New TGuy
			Cloak.MRndPlace()
			PlaySound SndPickup
		EndIf
		EndIf
		
		If Cloak<>Null
		If FDistToTarget(Cloak.XPos, Cloak.YPos, XPos,YPos)<10 And TPlayerStats.Explosives
			ModeCounter=60
			GameMode=EXPLOMODE
			PlaySound SndExplosion
			'Print " ExploDeath"
		EndIf
		EndIf
		If TPlayerStats.Goggles=True
			If Rnd(1)<0.05 Then PlaySound SndScan
		EndIf
		
	End Method
	
	Method MPlayerDraw()
	If GameMode=SPLATMODE
		SetColor 255,255,255
		SetScale 2,1
		DrawImage SplatGfx, Xpos, YPos
	Else
		SetScale 1,1
		Local r = TPlayerStats.AlertDist
		Local x,y,i
		
		SetColor 120,40,10
		For i=0 To 359 Step 90
		x = XPos +Sin(TPlayerStats.AlertAngle+i-5)*r
		y = YPos -Cos(TPlayerStats.AlertAngle+i-5)*r
		SetColor 120,40,0
		Plot x,y Plot x+1,y
		x = XPos +Sin(TPlayerStats.AlertAngle+i-10)*r
		y = YPos -Cos(TPlayerStats.AlertAngle+i-10)*r
		SetColor 120,40,0
		Plot x,y Plot x+1,y
		x = XPos +Sin(TPlayerStats.AlertAngle+i)*r
		y = YPos -Cos(TPlayerStats.AlertAngle+i)*r
		SetColor 170,60,10
		Plot x,y Plot x+1,y
		Next
		
		
		If TPlayerStats.Running
			If GlobalRunFrame = WalkFrame 
				SetScale 2,1
			Else
				SetScale -2,1
			EndIf
		Else
			If GlobalWalkFrame = WalkFrame 
				SetScale 2,1
			Else
				SetScale -2,1
			EndIf
		EndIf
		If TPlayerStats.Goggles=False
		SetColor 255,255,255
		DrawImage BodyGfx, XPos, YPos, 33
		Else ' Goggles on
		SetColor 255,255,255
		DrawImage BodyGfx, XPos, YPos, 34
		EndIf
	EndIf
	End Method
	
	
	
	
	Method MRoam()
		If Rnd(100)<2
				If Rnd(100)< 80
					Turn=0 ' ahead
				Else
					Turn=Rnd(3)-1
				EndIf
		EndIf

		Ang:+Turn
		' Angle Bounds
		If Ang<0 Then Ang:+360
		If Ang=>360 Then Ang:-360
		' Border Bounds
		If XPos<ARENA_LEFTMARGIN Then Ang = 90
		If YPos<ARENA_TOPMARGIN Then Ang = 180
		If XPos=>ARENA_RIGHTMARGIN Then Ang = 270
		If YPos=>ARENA_BOTTOMMARGIN Then Ang = 0
	End Method
	
	Method MAddVel()
		XPos:+XVel
		YPos:+YVel
	End Method
	
	Function FRndAng(a)
		a:+Rnd(-30,30)
		If a<0 Then a:+360
		If a=>360 Then a:-360
		Return a
	End Function
	
	Function FAngleToTarget:Int(x1,y1,x2,y2)
		Local a,xd,yd
		xd=x1-x2
		yd=y2-y1
		a=ATan2(xd,yd)
		Return a
	End Function
	
	Function FDistToTarget:Int(x1,y1,x2,y2)
		Local d,xd,yd
		xd=x1-x2
		yd=y2-y1
		d = Sqr(xd^2+yd^2)
		Return d
	End Function
	
	Function FWithinArenaBounds(x,y)
		If x < ARENA_LEFTMARGIN Or y < ARENA_TOPMARGIN Then Return False
		If x => ARENA_RIGHTMARGIN Or y => ARENA_BOTTOMMARGIN Then Return False
		Return True 
	End Function
	
End Type

